/**
* This is the main Blank Simple C++ Project program file.
*/

#include "PropWare/hd44780.h"
#include "PropWare/printer/printer.h"

using namespace PropWare;

// Control pins
const Port::Mask RS = Port::P16;
const Port::Mask RW = Port::P17;
const Port::Mask EN = Port::P18;

// Data pins
const Port::Mask FIRST_DATA_PIN = Port::P19;
const HD44780::Bitmode BITMODE = HD44780::BM_8;
const HD44780::Dimensions DIMENSIONS = HD44780::DIM_16x4;

int main(){
  HD44780 lcd;
  lcd.start(FIRST_DATA_PIN, RS, RW, EN, BITMODE, DIMENSIONS);
  
  // At this point, you could start writing to your LCD. There is no support for formatted
  // text though - like printf("%d", 3). If all you need is strings and not numbers, this 
  // is a great solution because it requires very little code space
  lcd.puts("Hello, world!");
  lcd.put_char('\n');
  
  // This solution allows for easy printing of numbers
  Printer lcdPrinter(&lcd);
  lcdPrinter.printf("Str: %s; #%d", "foo", 3);

  return 0;
}
